=== debian/changelog ===
aflplusplus (2.67c-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Revert "Switch to clang 11"
  * Fix broken symlinks (Closes: #968263)

  [ Raphaël Hertzog ]
  * New upstream version 2.67c
    - this versions disables -march=native when SOURCE_DATE_EPOCH is set
      Closes: #968336
  * Update patches for new upstream release
  * Fix installation path of helper libraries (Closes: #969151)
  * Switch to debhelper compat 13
  * Switch to clang/llvm 10
  * Install the upstream manual pages
  * Update Add-missing-CPPFLAGS.patch to cover afl-performance.o too

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 28 Aug 2020 21:15:22 +0200

aflplusplus (2.66c-1) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Rely on LLVM_CONFIG environment variable to force usage of a specific
    CLANG version
  * Don't duplicate LLVM major version in binary package dependencies

  [ Samuel Henrique ]
  * Configure git-buildpackage for Debian

  [ Sophie Brun ]
  * New upstream version 2.66c (Closes: #956986)
  * Remove unneeded patches
  * Switch to clang 11
  * Update build and installation for new release
  * Wrap-and-sort
  * Update debian/copyright
  * Update source/lintian-overrides
  * Add transitional packages (Closes: #942291)
  * Add a patch to fix spelling errors
  * Don't install upstream installation documentation
  * Patch to add missing CPPFLAGS
  * Bump Standards-Version to 4.5.0 (no change)
  * Re-enable build log scanner as #948009 is fixed
  * Add a patch to fix the file-references-package lintian info

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 07 Aug 2020 11:48:29 +0200
