=== debian/changelog ===
aflplusplus (2.68c-1) unstable; urgency=medium

  * New upstream version 2.68c
  * Add a patch to improve reproducibility (Closes: #969320)
  * Improve long description to make it clear that afl is unmaintained
    (Closes: #973557)
  * Switch to clang/LLVM 11 (Closes: #974783)
  * Drop all patches, they have been merged upstream.

 -- Raphaël Hertzog <raphael@offensive-security.com>  Tue, 17 Nov 2020 12:06:15 +0100
