=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends:
- clang-10,
+ clang-11,
  debhelper-compat (= 13),
  dh-buildinfo,
- llvm-10-dev,
+ llvm-11-dev,
  python3-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/vanhauser-thc/AFLplusplus
@@ -36,7 +36,7 @@
  essentially no configuration, and seamlessly handles complex, real-world use
  cases - say, common image parsing or file compression libraries.
  .
- This package is a fork of the afl package that is no longer maintained.
+ afl++ is a fork of the unmaintained afl.
 
 Package: afl++-clang
 Architecture: any
