=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 # Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
-export LLVM_MAJOR_VERSION = 10
+export LLVM_MAJOR_VERSION = 11
 export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)
 
 %:
