=== debian/tests/control ===
Tests: smoke-test-gcc
Depends: afl++, build-essential
Restrictions: allow-stderr

Tests: smoke-test-clang
Depends: afl++-clang, build-essential
Restrictions: allow-stderr

Tests: smoke-test-clang-fast
Depends: afl++-clang, build-essential
Restrictions: allow-stderr

Tests: adequate-afl
Depends: adequate, afl++

Tests: adequate-afl-clang
Depends: adequate, afl++-clang
